%define kver 2.4.21
%define krpmver 47.28AX
%define drvsuff V580A2-1

Summary:       A320raid (Adaptec close source driver)
Name:          kernel-driver-a320raid
Version:       3.00.071
Release:       %{kver}_%{krpmver}_2
License:       proprietary
Group:         System Environment/Kernel
URL:           http://www.adaptec.com/
Source:        a320raid-src-%{version}-%{drvsuff}.tgz
Source1:       filter-requires-kernel.sh
Patch0:        a320raid-rhlikekernel.patch
Patch1:        a320raid-3.00.070-writebuffer.patch
NoSource:      0

BuildPreReq:   kernel-source = %{kver}-%{krpmver}
Prereq:      kernel = %{kver}-%{krpmver}

BuildRoot:     %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: i386 i686 ia32e x86_64

%define __perl_requires %{SOURCE1}

%description
This package contains the a320raid kernel module.
Note that this driver does not licensed by the 
OpenSource(TM) term.

%package -n kernel-BOOT-driver-a320raid
Summary: A320raid (Adaptec close source driver) for BOOT kernel
Group: System Environment/Kernel
Prereq: kernel-BOOT = %{kver}-%{krpmver}

%description -n kernel-BOOT-driver-a320raid
This package contains the a320raid kernel module for BOOT kernel

%package -n kernel-smp-driver-a320raid
Summary: A320raid (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp = %{kver}-%{krpmver}

%description -n kernel-smp-driver-a320raid
This package contains the a320raid kernel module for smp kernel

%package -n kernel-hugemem-driver-a320raid
Summary: A320raid (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem = %{kver}-%{krpmver}

%description -n kernel-hugemem-driver-a320raid
This package contains the a320raid kernel module for hugemem kernel

%prep
%setup -q -c a320raid
%patch0 -p0
%patch1 -p1

## copy kernel tree for build
/bin/cp -a /usr/src/linux-%{kver}-%{krpmver} .
cd linux-%{kver}-%{krpmver}
## for safe
make clean
ln -s ../../../a320raid drivers/scsi/a320raid
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -prep/" Makefile
#perl -p -i -e "s/^NAME.*/NAME = Asianux/" Makefile
cd ..

%build
rm -rf $RPM_BUILD_ROOT
cd linux-%{kver}-%{krpmver}

BuildDriver() {
  make -s mrproper
  KernelVer=%{kver}-%{krpmver}$1
  ModuleDir=$RPM_BUILD_ROOT/lib/modules/$KernelVer/kernel/drivers/scsi
  mkdir -p $ModuleDir
  perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krpmver}$1/" Makefile
  if [ -n "$1" ]; then
    cp -a configs/kernel-%{kver}-%{_target_cpu}-$1.config .config
  else
    cp -a configs/kernel-%{kver}-%{_target_cpu}.config .config
  fi
  make -s oldconfig_nonint
  make -s oldconfig_nonint
  make -s scripts/mkdep
  make -s dep
  make -s include/linux/version.h
  #ln -sf linux/makefiles/Makefile.k24.a320raid drivers/scsi/a320raid/Makefile
  make -s SUBDIRS=drivers/scsi/a320raid CONFIG_SCSI_A320RAID=m modules
  cp -a drivers/scsi/a320raid/a320raid.o $ModuleDir
  rm -f drivers/scsi/a320raid/*o
  make clean
}

# Build driver for each kernels
%ifarch i386
BuildDriver BOOT
%endif
%ifarch i686 x86_64 ia32e
BuildDriver
%endif
%ifarch i686 x86_64
BuildDriver smp
%endif
%ifarch i686
BuildDriver hugemem
%endif

cd ..

%install

%clean
rm -rf ${RPM_BUILD_ROOT}

%ifarch i386
%post -n kernel-BOOT-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}BOOT
exit 0
%endif

%ifarch i686 x86_64 ia32e
%post
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0
%endif

%ifarch i686 x86_64
%post -n kernel-smp-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0
%endif

%ifarch i686
%post -n kernel-hugemem-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch i386
%postun -n kernel-BOOT-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}BOOT %{kver}-%{krpmver}BOOT
exit 0
%endif

%ifarch i686 x86_64 ia32e
%postun
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0
%endif

%ifarch i686 x86_64
%postun -n kernel-smp-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0
%endif

%ifarch i686
%postun -n kernel-hugemem-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch i386
%files -n kernel-BOOT-driver-a320raid
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}BOOT/kernel/drivers/scsi/*
%endif

%ifarch i686 x86_64 ia32e
%files
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/*
%endif

%ifarch i686 x86_64
%files -n kernel-smp-driver-a320raid
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/*
%endif

%ifarch i686
%files -n kernel-hugemem-driver-a320raid
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/*
%endif

%changelog
* Thu Mar 01 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.23AX

* Fri Jul 14 2006 Hiroshi Hara <hhara@miraclelinux.com>
- Rebuild for kernel-2.4.21-40.7AX
- Update to 3.00.071-V580A2-1
- deal with PreReq properly

* Wed Dec 28 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Rebuild for kernel-2.4.21-37.18AX

* Thu Nov 10 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Kernel 2.4 rpm

* Tue Nov  1 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change default write buffer flag

* Thu Oct 27 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change package name to kernel-<tag>-driver-<driver_name>
- Asianux 1.0 support

* Tue Oct 25 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Initial packaging

